package com.dbmaestro.urbancode.plugin

def helper = new PropertyHelper(this.args[0], this.args[1])
def exitStatus = -1
def propertyValue = null

try {
    def jarPath = helper.getAgentJarPath()
    def command = "java -jar $jarPath "
    List commandArgs = ['-AddSchema']
    // common parameters
    commandArgs.addAll(helper.getCommonParameters())

    // required local parameters
    commandArgs.addAll(helper.getPropertyValue('dbmDisplayName', '-DisplayName'))
    commandArgs.addAll(helper.getPropertyValue('dbmHost', '-Host'))
    commandArgs.addAll(helper.getPropertyValue('dbmPort', '-Port'))
    commandArgs.addAll(helper.getPropertyValue('dbmServerInstance', '-ServerInstance'))
    commandArgs.addAll(helper.getPropertyValue('dbmServiceInstanceIdentification', '-ServiceInstanceIdentification'))
    commandArgs.addAll(helper.getPropertyValue('dbmDBUser', '-DBUser'))
    commandArgs.addAll(helper.getPropertyValue('dbmDBPassword', '-DBPassword'))
    commandArgs.addAll(helper.getPropertyValue('dbmDBCyberArkSafe', '-DBCyberArkSafe'))
    commandArgs.addAll(helper.getPropertyValue('dbmDBCyberArkFolder', '-DBCyberArkFolder'))
    commandArgs.addAll(helper.getPropertyValue('dbmDBCyberArkObject', '-DBCyberArkObject'))
    commandArgs.addAll(helper.getPropertyValue('dbmSysUser', '-SysUser'))
    commandArgs.addAll(helper.getPropertyValue('dbmTablespace', '-Tablespace'))
    commandArgs.addAll(helper.getPropertyValue('dbmSysPassword', '-SysPassword'))
    commandArgs.addAll(helper.getPropertyValue('dbmSysCyberArkSafe', '-SysCyberArkSafe'))
    commandArgs.addAll(helper.getPropertyValue('dbmSysCyberArkFolder', '-SysCyberArkFolder'))
    commandArgs.addAll(helper.getPropertyValue('dbmSysCyberArkObject', '-SysCyberArkObject'))
    command = command + commandArgs.join(' ')
    println("Invoking DBmaestro Agent with command: " + command)

    Process process = command.execute()
    def out = new StringBuffer()
    def err = new StringBuffer()
    process.consumeProcessOutput(out, err)
    process.waitFor()
    if (out.size() > 0)
        println out
    if (err.size() > 0)
        println err
    exitStatus = process.exitValue()
}
catch (e) {
    println e
    exitStatus = -1
}
finally {
    System.exit(exitStatus)
}