package com.dbmaestro.urbancode.plugin

def helper = new PropertyHelper(this.args[0], this.args[1])
def exitStatus = -1
def propertyValue = null

try {
    def jarPath = helper.getAgentJarPath()
    def command = "java -jar $jarPath "
    List commandArgs = ['-UpdateTagTypeName']
    // common parameters
    commandArgs.addAll(helper.getCommonParameters())

    // required local parameters
    commandArgs.addAll(helper.getPropertyValue('dbmTagTypeName', '-TagTypeName'))
    commandArgs.addAll(helper.getPropertyValue('dbmNewTagTypeName', '-NewTagTypeName'))
    command = command + commandArgs.join(' ')
    println("Invoking DBmaestro Agent with command: " + command)

    Process process = command.execute()
    def out = new StringBuffer()
    def err = new StringBuffer()
    process.consumeProcessOutput(out, err)
    process.waitFor()
    if (out.size() > 0)
        println out
    if (err.size() > 0)
        println err
    exitStatus = process.exitValue()
}
catch (e) {
    println e
    exitStatus = -1
}
finally {
    System.exit(exitStatus)
}