package com.dbmaestro.urbancode.plugin

import com.urbancode.air.AirPluginTool

class PropertyHelper {
    private def apTool
    private def properties

    public PropertyHelper(def inFile, def outFile) {
        apTool = new AirPluginTool(inFile, outFile)
        properties = apTool.getStepProperties()
    }

    def getPropertyValue(String propertyName, String commandSwitch) {
        def propertyValue = properties[propertyName]

        if (propertyValue != null && propertyValue != '') {
            List pair = [commandSwitch, propertyValue]
            return pair
        } else {
            List pair = []
            return pair
        }
    }

    def getAgentJarPath() {
        return properties['dbmAutomationJarPath']
    }

    def getServerValue() {
        return getPropertyValue('dbmServer', '-Server')
    }

    def getUseSSLValue() {
        return getPropertyValue('dbmUseSSL', '-UseSSL')
    }

    def getAuthTypeValue() {
        return getPropertyValue('dbmAuthType', '-AuthType')
    }

    def getUserNameValue() {
        return getPropertyValue('dbmUserName', '-UserName')
    }

    def getPasswordValue() {
        return getPropertyValue('dbmPassword', '-Password')
    }

    def getCommonParameters() {
        List switchPropertyPairs = []
        switchPropertyPairs.addAll(getServerValue())
        switchPropertyPairs.addAll(getUseSSLValue())
        switchPropertyPairs.addAll(getAuthTypeValue())
        switchPropertyPairs.addAll(getUserNameValue())
        switchPropertyPairs.addAll(getPasswordValue())
        return switchPropertyPairs
    }
}